package org.spring.jmsinterop.builders;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class BuilderLookup {

	private List builderList;
	
    public BuilderLookup()
    {
        builderList = new ArrayList();
        createDefaultBuilders();
    }

    private void createDefaultBuilders()
    {
        builderList.add(new StringBuilder());
        builderList.add(new PrimitiveTypeBuilder());
        builderList.add(new BigDecimalBuilder());
        builderList.add(new TimestampBuilder());
        builderList.add(new MapBuilder());
        builderList.add(new CollectionBuilder());
        builderList.add(new ObjectBuilder());
    }

	public List getBuilderList() {
		return builderList;
	}

	public void setBuilderList(List builderList) {
		this.builderList = builderList;
	}
    
    public Builder getBuilderForClass(Class targetClass)
    {
    	for (Iterator iter = builderList.iterator(); iter.hasNext();) {
			Builder builder = (Builder) iter.next();
			if (builder.canBuild(targetClass))
			{
				return builder;
			}
		}
    	return null;
    }
}
