package org.spring.jmsinterop.gateways;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.spring.jmsinterop.bo.Portfolio;
import org.spring.jmsinterop.bo.Trade;
import org.springframework.jms.core.support.JmsGatewaySupport;

/**
 * Class that sends messages (primarily) to the user apps.
 *
 */
public class JmsUserGateway extends JmsGatewaySupport implements UserGateway {

	protected final Log logger = LogFactory.getLog(getClass());
	
	public void send(Trade trade)
	{
		logger.info("Sending trade.");
		getJmsTemplate().convertAndSend(trade);
	}

	public void send(Portfolio portfolio) {
		logger.info("Sending Porfolio.");
		getJmsTemplate().convertAndSend(portfolio);
		
	}
}
