package org.spring.jmsinterop.testdrivers;

import java.util.HashMap;
import java.util.Map;

import javax.jms.ConnectionFactory;

import org.springframework.jms.core.JmsTemplate;

import com.tibco.tibjms.TibjmsQueueConnectionFactory;

public class SimpleMarketDataSender {

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		sendHelloWorld();

	}

	private static void sendHelloWorld() throws InterruptedException {
		
		String serverUrl = "tcp://localhost:7222";
		ConnectionFactory connFactory = new TibjmsQueueConnectionFactory(
				serverUrl);
		JmsTemplate jmsTemplate = new JmsTemplate(connFactory);
		jmsTemplate.setPubSubDomain(true);
		jmsTemplate.setDefaultDestinationName("APP.STOCK");
		
		System.out.print("publishing market data messages... ");
		
		for (int i = 0; i < 5; i++) {			
			System.out.print(i+1 + ".");
			Map data = new HashMap();
			data.put("TICKER", "CSCO");
			data.put("PRICE", "28." + i);
			jmsTemplate.convertAndSend(data);
			
			Thread.sleep(1000);
		}
		
		System.out.println("done.");
	}

}
