using System;
using System.Collections;
using System.Reflection;
using Spring.JmsInterop.Converters;
using TIBCO.EMS;

namespace Spring.JmsInterop.Builders
{
    public abstract class AbstractCollectionBuilder : IBuilder
    {
        public abstract bool CanBuild(Type targetType);

        public virtual void AddValue(MapMessage mm, Session session, ConversionContext conversionContext, string fieldName, Type fieldType, object fieldVal)
        {
            ICollection collection = fieldVal as ICollection;
            MapMessage collectionMsg = session.CreateMapMessage();
            collectionMsg.SetBooleanProperty("JMS_TIBCO_MSG_EXT", true);
            mm.SetObject(fieldName, collectionMsg);

            int i = 0;
            foreach (object objectToConvert in collection)
            {
                //TODO what about collections of simple types..?  Will this be handled 
                //when introduce array converter first?
                collectionMsg.SetObject(i.ToString(), conversionContext.ConvertToMessage(objectToConvert, session));
                i++;              
                
            }
        }
        public abstract void SetValue(MapMessage mapMessage, ConversionContext conversionContext, object targetObject, object fieldVal, FieldInfo targetFieldInfo);
    }
}
