using System;
using System.Collections;
using Spring.Messaging.Tibco.Ems.Support.Converter;

namespace Spring.JmsInterop.Builders
{
    public class BuilderLookup
    {
        private IList builderList;


        public BuilderLookup()
        {
            builderList = new ArrayList();
            CreateDefaultBuilders();
        }

        private void CreateDefaultBuilders()
        {
            builderList.Add(new StringBuilder());
            builderList.Add(new PrimitiveTypeBuilder());
            builderList.Add(new DecimalBuilder());
            builderList.Add(new DateTimeBuilder());
            builderList.Add(new PrimitiveArrayBuilder());
            builderList.Add(new DictionaryBuilder());
            builderList.Add(new ListBuilder());
            builderList.Add(new ObjectBuilder());
        }


        public IList BuilderList
        {
            get { return builderList; }
            set { builderList = value; }
        }

        public IBuilder GetBuilderForType(Type fieldType)
        {
            foreach (IBuilder builder in builderList)
            {
                if (builder.CanBuild(fieldType))
                {
                    return builder;
                }
            }
            throw new MessageConversionException("No builder defined for type " + fieldType);
        }
    }
}
