
using System;
using System.Reflection;
using Spring.JmsInterop.Converters;
using TIBCO.EMS;

namespace Spring.JmsInterop.Builders
{
    public class StringBuilder : IBuilder
    {
        public bool CanBuild(Type targetType)
        {
            return targetType.Equals(typeof(String)); 
        }

        public void AddValue(MapMessage mm, Session session, 
                             ConversionContext conversionContext, 
                             string fieldName, Type fieldType, object fieldVal)
        {
            mm.SetObject(fieldName, fieldVal as string);
        }

        public void SetValue(MapMessage mapMessage, ConversionContext conversionContext, object targetObject, object fieldVal, FieldInfo targetFieldInfo)
        {
            targetFieldInfo.SetValue(targetObject, fieldVal as string);
        }

    }
}