
using System.Collections;
using log4net;
using Spring.JmsInterop.Bo;
using Spring.JmsInterop.UI;

namespace Spring.JmsInterop.Handlers
{
    public class StockAppHandler
    {
        #region Logging Definition

        private readonly ILog log = LogManager.GetLogger(typeof(StockAppHandler));

        #endregion

        private StockController stockController;


        public StockController StockController
        {
            get { return stockController; }
            set { stockController = value; }
        }

        public void HandleObject(IDictionary data)
        {
            log.InfoFormat("Received market data.  Ticker = {0}, Price = {1}", data["TICKER"], data["PRICE"]);
           
            // forward to controller to update view
            stockController.UpdateMarketData(data);
            
        }
        
        
        public void HandleObject(Trade trade)
        {
            log.InfoFormat("Received trade.  Ticker = {0}, Price = {1}", trade.Ticker, trade.Price);
            stockController.UpdateTrade(trade);
        }
        
        public void HandleObject(Portfolio portfolio)
        {
            log.InfoFormat("Received portfolio.  Name = " + portfolio.PortfolioName);
            stockController.UpdatePortfolio(portfolio);
        }
        
        public void HandleObject(object catchAllObject)
        {
            log.Info("could not handle object = " + catchAllObject.GetType());
        }
    }
}
